#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys

#message de dbut
print "----------<AddCppGettersSettersIntoIndex.py>----------"

#lire le fichier C:\perforce\eng\vision\products\Open_eVision\releases\1.1.5\doc\DocGen\Logs\cppGettersAndSetters.txt
#pour chaque item: matcher ::Set ou ::Get dedans
#lire le fichier index.hhk
#trouver les entres contenant item sans Set ou Get
#copier l'entre, remplacer :: par ::Set ou ::Get selon
#ajouter la nouvelle entre  l'index
#trier l'index sur le critre du titre de l'item


# ################################################################################################
# fct qui compare les strings (dans le 1er lment du tableau pass en param), indpendamment de la casse
def cmpLower(x, y):
  return cmp(x[0].lower(), y[0].lower())

# ################################################################################################
 

#Expressions rgulires  
reSet = re.compile("::Set")
reGet = re.compile("::Get")
reEndIndex = re.compile("</UL>\s*?</BODY></HTML>")
reItem = re.compile("(<LI>\s*?<OBJECT type=\"text/sitemap\">\s*?<param name=\"Name\" value=\")(.*?\">.*?</OBJECT>)", re.DOTALL)



## ###############################################################################

#ouverture et lecture de la liste
listFile = open("C:\\perforce\\eng\\vision\\products\\Open_eVision\\releases\\1.1.5\\doc\\DocGen\\Logs\\cppGettersAndSetters.txt","r+")
list = listFile.readlines()
listFile.close()


#rcuprer le contenu de l'index
indexTxt = euresys.readFromFile("index.hhk")

flag = "False"
newEntry = ""

for line in list:
  sets = reSet.findall(line)
  if len(sets) == 1:
    #parcourir l'index et chercher l'entre qui correspond  la property (line - Set/Get)
    property = line.strip()
    property = property.replace("::Set", "::")
    print "Searching for property " + property + "."
    reEntry = re.compile("<LI>\s*?<OBJECT type=\"text/sitemap\">\s*?<param name=\"Name\" value=\"" + property + "\">.*?</OBJECT>", re.DOTALL)
    entries = reEntry.findall(indexTxt)
    if len(entries) == 1:
      #remplacer l'entre par elle-mme + Set
      entry = entries[0]
      newEntry = entry.replace("::", "::Set")
  else:
    gets = reGet.findall(line)
    if len(gets) == 1:
      #parcourir l'index et chercher l'entre qui correspond  la property (line - Set/Get)
      property = line.strip()
      property = property.replace("::Get", "::")
      print "Searching for property " + property + "."
      reEntry = re.compile("<LI>\s*?<OBJECT type=\"text/sitemap\">\s*?<param name=\"Name\" value=\"" + property + "\">.*?</OBJECT>", re.DOTALL)
      entries = reEntry.findall(indexTxt)
      if len(entries) == 1:
        #remplacer l'entre par elle-mme + Get
        entry = entries[0]
        newEntry = entry.replace("::", "::Get")
  print newEntry
  #ajouter la newEntry en fin d'index
  endIndex = reEndIndex.findall(indexTxt)
  if len(endIndex) == 1:
    indexTxt = indexTxt.replace(endIndex[0], newEntry + "</UL>\n</BODY></HTML>")



################################# trier les entres #############################
#lister tous les reItem
listOfItems = []
items = reItem.findall(indexTxt)
if len(items) != 0:
  for eachItem in items:
    #ajouter chaque item  la liste
    listOfItems.append([eachItem[1], eachItem[0]])

  #trier la liste
  listOfItems.sort(cmpLower)

  #reconstituer l'index  partir de cette liste trie
  newIndexTxt = ""
  newIndexTxt += "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//EN\">\n<HTML>\n<HEAD></HEAD>\n<BODY>\n<OBJECT type=\"text/site properties\">\n\t<param name=\"FrameName\" value=\"BODY\">\n\t<param name=\"ExWindow Styles\" value=\"0x0\">\n\t<param name=\"Window Styles\" value=\"0x7\">\n</OBJECT>\n<UL>\n"
  for eachItem in listOfItems:
    newIndexTxt += eachItem[1] + eachItem[0] + "\n"
  newIndexTxt += "</UL>\n</BODY></HTML>"
  
  #index modifi
  flag = "True"


if flag == "True":
  euresys.writeToFile("index.hhk", newIndexTxt)

#message de fin
print "----------</AddCppGettersSettersIntoIndex.py>----------"

