#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys


#message de dbut
print "----------<AdjustContext.py>----------"

########################################################
PRODUCT = ""
BOOK = ""
COLOR = ""

#1. ISOLER LE PRODUCT
#Rechercher la "possible doc" dans la hierarchy:
#L'ordre n'est pas anodin. Le script parcourt la liste des possible docs jusqu' ce que la 1re matche.
#Les docs de haut niveau doivent donc tre  la fin

allPossibleDocs = []
allPossibleDocs.append("Documentation Procedures")
allPossibleDocs.append("Euresys License Customer Web Portal Documentation")
allPossibleDocs.append("ActiveGigE for Open eVision Documentation")
allPossibleDocs.append("ActiveDcam for Open eVision Documentation")
allPossibleDocs.append("Open eVision C\+\+ Code Snippets")
allPossibleDocs.append("Open eVision \.NET Code Snippets")
allPossibleDocs.append("Open eVision ActiveX Code Snippets")
allPossibleDocs.append("Open eVision License Manager Documentation")
allPossibleDocs.append("Open eVision C\+\+ Reference")
allPossibleDocs.append("Open eVision \.NET Reference")
allPossibleDocs.append("Open eVision ActiveX Reference")
allPossibleDocs.append("Open eVision Quick Start Tutorials")
allPossibleDocs.append("Open eVision Functional Guide")
allPossibleDocs.append("Open eVision C\+\+ Programming Guide")
allPossibleDocs.append("Open eVision \.NET Programming Guide")
allPossibleDocs.append("Open eVision ActiveX Programming Guide")
allPossibleDocs.append("Getting Started with Open eVision Eval")
allPossibleDocs.append("Getting Started with Open eVision Studio")
allPossibleDocs.append("Analog Cables Documentation")
allPossibleDocs.append("Analog Cameras Documentation")
allPossibleDocs.append("Digital Cables Documentation")
allPossibleDocs.append("Digital Cameras Documentation")
allPossibleDocs.append("Picolo Handbook")
allPossibleDocs.append("PICOLO Alert Handbook")
allPossibleDocs.append("PICOLO Diligent Handbook")
allPossibleDocs.append("PICOLO Junior 4 Handbook")
allPossibleDocs.append("PICOLO Pro 2 Handbook")
allPossibleDocs.append("PICOLO Pro 3 Handbook")
allPossibleDocs.append("PICOLO Tetra Handbook")
allPossibleDocs.append("PICOLO Tymo Handbook")
allPossibleDocs.append("MIO Module Handbook")
allPossibleDocs.append("VEB Handbook")
allPossibleDocs.append("PICOLO U4/U8/U16 H.264 Documentation")
allPossibleDocs.append("PICOLO U4 H.264 PCI-104 Documentation")
allPossibleDocs.append("PICOLO V16 H.264 Documentation")
allPossibleDocs.append("Connecting Accessories for PICOLO H.264 Documentation")
allPossibleDocs.append("DOMINO Alpha 2 Handbook")
allPossibleDocs.append("DOMINO Delta Handbook")
allPossibleDocs.append("DOMINO Harmony Handbook")
allPossibleDocs.append("DOMINO Iota Handbook")
allPossibleDocs.append("DOMINO Melody Handbook")
allPossibleDocs.append("DOMINO Symphony Handbook")
allPossibleDocs.append("GRABLINK Avenue Handbook")
allPossibleDocs.append("GRABLINK Expert 2 Handbook")
allPossibleDocs.append("GRABLINK Express Handbook")
allPossibleDocs.append("GRABLINK Full Handbook")
allPossibleDocs.append("GRABLINK Quickpack CFA Handbook")
allPossibleDocs.append("GRABLINK Quickpack ColorScan Handbook")
allPossibleDocs.append("GRABLINK Value Handbook")
allPossibleDocs.append("PICOLO series Documentation")
allPossibleDocs.append("DOMINO series Documentation")
allPossibleDocs.append("GRABLINK series Documentation")
allPossibleDocs.append("MultiCam User Guide")
allPossibleDocs.append("MultiCam Reference")
allPossibleDocs.append("MultiCam C Reference")
allPossibleDocs.append("MultiCam C\+\+ Reference")
allPossibleDocs.append("MultiCam \.NET Reference")
allPossibleDocs.append("MultiCam ActiveX Reference")
allPossibleDocs.append("MultiCam DirectShow Reference")
allPossibleDocs.append("MultiCam Sample Programs")
allPossibleDocs.append("MultiCam Documentation")
allPossibleDocs.append("MultiCam Boards Documentation")
allPossibleDocs.append("Open eVision C\+\+ Documentation")
allPossibleDocs.append("Open eVision \.NET Documentation")
allPossibleDocs.append("Open eVision ActiveX Documentation")

allPossibleBooks = []
allPossibleBooks.append("C\+\+ Documentation")
allPossibleBooks.append("\.NET Documentation")
allPossibleBooks.append("ActiveX Documentation")
allPossibleBooks.append("Documentation")
allPossibleBooks.append("Handbook")
allPossibleBooks.append("User Guide")
allPossibleBooks.append("Functional Guide")
allPossibleBooks.append("C\+\+ Programming Guide")
allPossibleBooks.append("C\+\+ Code Snippets")
allPossibleBooks.append("\.NET Programming Guide")
allPossibleBooks.append("\.NET Code Snippets")
allPossibleBooks.append("ActiveX Programming Guide")
allPossibleBooks.append("ActiveX Code Snippets")
allPossibleBooks.append("C Reference")
allPossibleBooks.append("C\+\+ Reference")
allPossibleBooks.append("\.NET Reference")
allPossibleBooks.append("ActiveX Reference")
allPossibleBooks.append("DirectShow Reference")
allPossibleBooks.append("Reference") #has to be here, after the other "XXX Reference"
allPossibleBooks.append("Sample Programs")
allPossibleBooks.append("Getting Started with")
allPossibleBooks.append("Quick Start Tutorials")


########################################################
#2. EN DEDUIRE LES VARIABLES DE CONTEXTE
#En fonction de la "possible doc", dfinir PRODUCT, BOOK
#en fonction de PRODUCT, dfinir COLOR
productsCOLOR = {}
productsCOLOR["Analog Cables"] = "GRISVERT"
productsCOLOR["Analog Cameras"] = "GRISVERT"
productsCOLOR["Digital Cables"] = "GRISVERT"
productsCOLOR["Digital Cameras"] = "GRISVERT"
productsCOLOR["DOMINO series"] = "GRISVERT"
productsCOLOR["DOMINO Alpha 2"] = "GRISVERT"
productsCOLOR["DOMINO Delta"] = "GRISVERT"
productsCOLOR["DOMINO Harmony"] = "GRISVERT"
productsCOLOR["DOMINO Iota"] = "GRISVERT"
productsCOLOR["DOMINO Melody"] = "GRISVERT"
productsCOLOR["DOMINO Symphony"] = "GRISVERT"
productsCOLOR["MultiCam Boards"] = "GRISVERT"
productsCOLOR["Open eVision"] = "TURQUOISE"
productsCOLOR["Open eVision Eval"] = "TURQUOISE"
productsCOLOR["Open eVision Studio"] = "TURQUOISE"
productsCOLOR["Open eVision License Manager"] = "TURQUOISE"
productsCOLOR["ActiveGigE for Open eVision"] = "TURQUOISE"
productsCOLOR["ActiveDcam for Open eVision"] = "TURQUOISE"
productsCOLOR["Euresys License Customer Web Portal"] = "NEUTRE"
productsCOLOR["GRABLINK series"] = "GRISVERT"
productsCOLOR["GRABLINK Avenue"] = "GRISVERT"
productsCOLOR["GRABLINK Expert 2"] = "GRISVERT"
productsCOLOR["GRABLINK Express"] = "GRISVERT"
productsCOLOR["GRABLINK Full"] = "GRISVERT"
productsCOLOR["GRABLINK Quickpack CFA"] = "GRISVERT"
productsCOLOR["GRABLINK Quickpack ColorScan"] = "GRISVERT"
productsCOLOR["GRABLINK Value"] = "GRISVERT"
productsCOLOR["MultiCam"] = "GRISVERT"
productsCOLOR["PICOLO series"] = "GRISVERT"
productsCOLOR["Picolo"] = "GRISVERT"
productsCOLOR["PICOLO Alert"] = "GRISVERT"
productsCOLOR["PICOLO Diligent"] = "GRISVERT"
productsCOLOR["PICOLO Junior 4"] = "GRISVERT"
productsCOLOR["PICOLO Pro 2"] = "GRISVERT"
productsCOLOR["PICOLO Pro 3"] = "GRISVERT"
productsCOLOR["PICOLO Tetra"] = "GRISVERT"
productsCOLOR["PICOLO Tymo"] = "GRISVERT"
productsCOLOR["MIO Module"] = "GRISVERT"
productsCOLOR["VEB"] = "GRISVERT"
productsCOLOR["PICOLO U4/U8/U16 H.264"] = "IRRELEVANT"
productsCOLOR["PICOLO U4 H.264 PCI-104"] = "IRRELEVANT"
productsCOLOR["PICOLO V16 H.264"] = "IRRELEVANT"
productsCOLOR["Connecting Accessories for PICOLO H.264"] = "IRRELEVANT"
productsCOLOR["Documentation Procedures"] = "NEUTRE"


########################################################
#3. MODIFIER LE HTM A TOUS LES ENDROITS NECESSAIRES
#Chercher tous les endroits  redfinir et remplacer par les variables
########################################################


#construction des expressions rgulires
#trouver toute la hirarchie
reHierarchyAll = re.compile("<P id='hierarchy' class='Hierarchy'.*?>(.*)", re.IGNORECASE)
#localiser les places o on doit redfinir le contexte
reCOLOR = re.compile("<\!-- COLOR -->", re.IGNORECASE)
rePRODUCT = re.compile("<\!-- PRODUCT -->", re.IGNORECASE)
reBOOK = re.compile("<\!-- BOOK -->", re.IGNORECASE)

#rcuprer le nom du job en cours
jobName = euresys.getJobName()

#excution sur tous les fichiers htm du dossier
for f in os.listdir('.'):
  if euresys.getFileExtension(f) != ".htm":
    continue

  #rcuprer le contenu du fichier
  htmlTxt = euresys.readFromFile(f)
  
  flag = "False"
  docTitle = ""

  #trouver la hierarchy
  founds = reHierarchyAll.findall(htmlTxt)
  if len(founds) != 0:
    hierarchyAll = founds[0]
    #chercher un titre de doc dans hierarchyAll
    for eachPossibleDoc in allPossibleDocs:
      reOnePossibleDoc = re.compile(eachPossibleDoc)
      docTitles = reOnePossibleDoc.findall(hierarchyAll)
      #si un titre est trouv dans hierarchyAll, ok, on le prend ET ON SORT DE LA BOUCLE
      if len(docTitles) != 0:
        docTitle = docTitles[0]
        break

  
  if docTitle == "Documentation Procedures":
    PRODUCT = "DocumentationProcedures"
    BOOK = "EuresysInternalDocument"
    COLOR = "NEUTRE"
  else:      
    if docTitle != "":
      ########################################################
      # partir de docTitle, isoler PRODUCT et BOOK
      #chercher un book dans docTitle
      for eachPossibleBook in allPossibleBooks:
        reOnePossibleBook = re.compile(eachPossibleBook)
        books = reOnePossibleBook.findall(docTitle)
        if len(books) != 0:
          BOOK = books[0]
          if BOOK == "Getting Started with":
            PRODUCT = docTitle.replace(BOOK + " ", "")
            BOOK = "Getting Started"
          else:
            PRODUCT = docTitle.replace(" " + BOOK, "")
            BOOK = BOOK.replace(".", "")
            BOOK = BOOK.replace("/", "")
          COLOR = productsCOLOR[PRODUCT]
          PRODUCT = PRODUCT.replace(" ", "")
          PRODUCT = PRODUCT.replace("/", "")
          PRODUCT = PRODUCT.replace(".", "")
          PRODUCT = PRODUCT.replace("-", "")
          #ds qu'on a pu dfinir BOOK PRODUCT COLOR, on sort de la boucle
          break
      
  print "PRODUCT = " + PRODUCT
  print "BOOK = " + BOOK
  print "COLOR = " + COLOR
  
  ########################################################
  #remplacer les variables HTML par les valeurs issues du contexte
  #rePRODUCT
  founds = rePRODUCT.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, PRODUCT.replace(" ", ""))
      flag = "True"
  #reBOOK
  founds = reBOOK.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, BOOK.replace(" ", ""))
      flag = "True"
  #reCOLOR
  founds = reCOLOR.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, COLOR)
      flag = "True"

  ########################################################
  ## OBSOLETE from April 2010
  #lier la doc au bon fichier pdf (Picolo U et V only)
  #htmlTxt2 = htmlTxt.replace("<!-- here comes the relevant pdf -->", jobName)
  #if htmlTxt2 != htmlTxt:
  #  htmlTxt = htmlTxt2
  #  flag = "True"
      
  ########################################################
  #si le fichier a t modifi, le remplacer
  if flag == "True":
    euresys.writeToFile(f, htmlTxt)
  

#message de fin
print "----------</AdjustContext.py>----------"
