#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys


#message de dbut
print "----------<AdjustCover.py>----------"

#construction des expressions rgulires
reTitleLoc = re.compile("<!-- ici viendra le titre -->", re.IGNORECASE)
reTitle = re.compile("(<h[123] class=\"heading[123]\">.*</h[123]>)", re.IGNORECASE)
reTitleASupprimer = re.compile("</TABLE>..(..<h[123] class=\"heading[123]\">.*</h[123]>)", re.DOTALL)
reTableSettings = re.compile("<TABLE id=\"noanimation\" cellspacing='3' cellpadding='1'", re.IGNORECASE)
reTableSettings2 = re.compile("<TABLE id=\"animation\" cellspacing='3' cellpadding='1'", re.IGNORECASE) 
reContentLoc = re.compile("<!-- ici viendra le sommaire -->", re.IGNORECASE)
reContent = re.compile("(<p class=\"covertabletitle\">.*?</p>)</td>", re.IGNORECASE | re.DOTALL)
reContentASupprimer = re.compile("<table class=\"relatedtopics\" cellpadding='1' cellspacing='3' >.<tr valign=\"top\">.<td>.<p class=\"relatedheading\">.*?</table>", re.DOTALL)

#excution sur tous les fichiers htm du dossier
for f in os.listdir('.'):
  if euresys.getFileExtension(f) != ".htm":
    continue

  #rcuprer le contenu du fichier
  htmlTxt = euresys.readFromFile(f)
  
  flag = "False"

  ########################################################
  #si on est sur une page de cover, petite manip de couper-coller  faire:
  #il faut remettre le titre au-dessus du tableau
  #il faut remettre le contents dans le tableau
  #reTitleLoc
  titleLocs = reTitleLoc.findall(htmlTxt)
  if len(titleLocs) != 0:
    titleLoc = titleLocs[0]
    titles = reTitle.findall(htmlTxt)
    if len(titles) != 0:
      title = titles[0]
      htmlTxt = htmlTxt.replace(titleLoc, title)
      #SUPPRIMER l'ancien titre
      founds = reTitleASupprimer.findall(htmlTxt)
      if len(founds) != 0:
        htmlTxt = htmlTxt.replace(founds[0], "")
      flag = "True"  
  #reContentsLoc
  contentLocs = reContentLoc.findall(htmlTxt)
  if len(contentLocs) != 0:
    contentLoc = contentLocs[0]
    contents = reContent.findall(htmlTxt)
    if len(contents) != 0:
      content = contents[0]
      htmlTxt = htmlTxt.replace(contentLoc, content)
      #SUPPRIMER l'ancien content
      founds = reContentASupprimer.findall(htmlTxt)
      if len(founds) != 0:
        htmlTxt = htmlTxt.replace(founds[0], "")
      flag = "True"
      
  tableSettings = reTableSettings.findall(htmlTxt)
  if len(tableSettings) == 1:
    htmlTxt = htmlTxt.replace(tableSettings[0], "<TABLE id='noanimation' cellspacing='0' cellpadding='0'")
    flag = "True"
  tableSettings2 = reTableSettings2.findall(htmlTxt)
  if len(tableSettings2) == 1:
    htmlTxt = htmlTxt.replace(tableSettings2[0], "<TABLE id='animation' cellspacing='0' cellpadding='0'")
    flag = "True"

  ########################################################
  #si le fichier a t modifi, le remplacer
  if flag == "True":
    euresys.writeToFile(f, htmlTxt)

#message de fin
print "----------</AdjustCover.py>----------"
