#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys

#message de dbut
print "----------<InsertParameterTitle.py>----------"

#construction de l'expression rgulire qui trouvera le parameterTitle
reTitle = re.compile("<p class=\"parametertitle\">(.*?)</p>", re.IGNORECASE)
#construction de l'expression rgulire qui trouvera le parameterTitle
reParagraph = re.compile("<p class=\"parametertitle\">.*?</p>", re.IGNORECASE)
#trouver l'endroit ou crire le title
reLocation = re.compile("<p id='pTitle'></p>", re.IGNORECASE)

#excution sur tous les fichiers htm du dossier
for f in os.listdir('.'):
  if euresys.getFileExtension(f) != ".htm":
    continue

  htmlTxt = euresys.readFromFile(f)

  #est-ce qu'on trouve un endroit o mettre le parameterTitle?
  location = reLocation.findall(htmlTxt)
  if len(location) != 0:
      #est-ce qu'on trouve un parametertitle?
      title = reTitle.findall(htmlTxt)
      if len(title) != 0:
          #il n'y en a qu'1 et c'est celui-l...
          title = title[0]
          #cration de la nouvelle chane de titre
          newTitle = "<p id='pTitle'>" + title + "</p>"
          
          #remplacer l'endroit o mettre le parameterTitle par le nouveau title
          htmlTxt = htmlTxt.replace(location[0], newTitle)
          
          #remplacer l'ancien paragraphe par rien
          paragraph = reParagraph.findall(htmlTxt)
          htmlTxt = htmlTxt.replace(paragraph[0], "")
          
          #crire dans le fichier
          euresys.writeToFile(f, htmlTxt)

#message de fin
print "----------</InsertParameterTitle.py>----------"
