#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import shutil
import urllib
import euresys

#avec le dossier parent:
#   le copier
#   le coller dans \\Sybillineii\communications\Documentation
#dans \\Sybillineii\communications\Documentation\dossier parent:
#   supprimer les fichiers privs



#message de dbut
print "----------<PutHtmOnIntranetDraft.py>----------"

#nom du dossier grand-parent
jobType = euresys.getJobType()
jobName = euresys.getJobName()

docPath = "\\\\Sybillineii\\communications\\Documentation\\_DRAFT\\"

jobPath = docPath + jobName
pubPath = jobPath + "_publishing"
bakPath = jobPath + "_backup"

#si le dossier existe dj sur le serveur
if os.path.isdir(jobPath):
  
  #remove the backup
  if os.path.isdir(bakPath):
    #remove the supposed read-only attribute on the files within
    for files in os.walk(bakPath):
      for f in files[2]:
        if not os.access(bakPath + "\\" + f, os.W_OK):
          os.chmod(bakPath + "\\" + f, 0777)
    #remove the existing backup directory
    shutil.rmtree(bakPath, True)

#si le dossier "publishing" existe dj sur le serveur
if os.path.isdir(pubPath):
  #remove the supposed read-only attribute on the files within
  for files in os.walk(pubPath):
    for f in files[2]:
      if not os.access(pubPath + "\\" + f, os.W_OK):
        os.chmod(pubPath + "\\" + f, 0777)
  #remove the existing publishing directory
  shutil.rmtree(pubPath, True)

#copy into _publishing    
print "Copying " + jobName + " in " + docPath + "..."
shutil.copytree(os.path.abspath("."), docPath + jobName + "_publishing")
#remove the supposed read-only attribute on the files within _publishing
for files in os.walk(pubPath):
  for f in files[2]:
    if not os.access(pubPath + "\\" + f, os.W_OK):
      os.chmod(pubPath + "\\" + f, 0777)

#if the final directory exists on the server, then rename as backup...
if os.path.isdir(jobPath):
  print "Backing up..."
  os.rename(jobPath, bakPath)
  print "Pre-existing " + jobName + " in " + docPath + " is backed up."
  
#rename _publishing to jobName
os.rename(pubPath, jobPath)
print jobName + " copied in " + docPath + "."

#delete unnecessary files in the job folder
print "Deleting unnecessary files on the server..."
for file in euresys.getPrivateFilesList():
  try:
    os.remove(jobPath + "\\" + file)
    print jobPath + "\\" + file + " deleted successfully."
  except OSError:
    print file + " not found."

#message de fin
print "----------</PutHtmOnIntranetDraft.py>----------"

