#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys


#message de dbut
print "----------<RewriteNavigation.py>----------"

#construction des expressions rgulires qui trouveront les liens previous, up, next gnrs par AIT
# <p class="navigationprevious"><a href="25849.htm" target="_self">
rePrevious = re.compile("<p class=\"navigationprevious\">(<a href=\".*?.htm\" target=\"_self\">)", re.IGNORECASE)
reUp = re.compile("<p class=\"navigationup\">(<a href=\".*?.htm\" target=\"_self\">)", re.IGNORECASE)
reNext = re.compile("<p class=\"navigationnext\">(<a href=\".*?.htm\" target=\"_self\">)", re.IGNORECASE)

#construction de l'expression rgulire qui trouvera le tableau des related topics,  supprimer
reRelated = re.compile("(<table class=\"relatedtopics\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">.*?<p class=\"navigation.*?</table>)", re.IGNORECASE | re.DOTALL)

#excution sur tous les fichiers htm du dossier
for f in os.listdir('.'):
  if euresys.getFileExtension(f) != ".htm":
    continue

  #rcuprer le contenu du fichier
  htmlTxt = euresys.readFromFile(f)
  
  flag = "False"

  #PREVIOUS trouver la loc
  previousLoc = "<IMG id='navigationprevious' alt='' src='PreviousInactif.png' hspace='0' vspace='0' border='0'>"
  if htmlTxt.find(previousLoc) != -1:
    #trouver le lien correct
    previous = rePrevious.findall(htmlTxt)
    if len(previous) == 1:
      newPrevious = previous[0] + "<IMG id='imgNavPrevious' alt='Previous' src='PreviousNEUTRE.png' hspace='0' vspace='0' border='0'></A>"
      #remplacer
      htmlTxt = htmlTxt.replace(previousLoc, newPrevious)
      flag = "True"
  
  #UP trouver la loc
  upLoc = "<IMG id='navigationup' alt='' src='UpInactif.png' hspace='0' vspace='0' border='0'>"
  if htmlTxt.find(upLoc) != -1:
    #trouver le lien correct
    up = reUp.findall(htmlTxt)
    if len(up) == 1:
      newUp = up[0] + "<IMG id='imgNavUp' alt='Up' src='UpNEUTRE.png' hspace='0' vspace='0' border='0'></A>"
      #remplacer
      htmlTxt = htmlTxt.replace(upLoc, newUp)
      flag = "True"
  
  #NEXT trouver la loc
  nextLoc = "<IMG id='navigationnext' alt='' src='NextInactif.png' hspace='0' vspace='0' border='0'>"
  if htmlTxt.find(nextLoc) != -1:
    #trouver le lien correct
    next = reNext.findall(htmlTxt)
    if len(next) == 1:
      #ne mettre le lien que si le fichier Next n'est pas "Disclaimer", "Contact Us", "About Euresys Documentation"
      #si pas de "Disclaimer", "Contact Us", "About Euresys Documentation", euresys.getFileName retourne "", next[0].find(...) retourne 0
      #si filename non trouv, find retourne -1
      if next[0].find(euresys.getFileName("Disclaimer")) <= 0:
        if next[0].find(euresys.getFileName("Contact Us")) <= 0:
          if next[0].find(euresys.getFileName("About Euresys Documentation")) <= 0:
            newNext = next[0] + "<IMG id='imgNavNext' alt='Next' src='NextNEUTRE.png' hspace='0' vspace='0' border='0'></A>"
            #remplacer
            htmlTxt = htmlTxt.replace(nextLoc, newNext)
            flag = "True"
  
  #HOME trouver la loc
  homeLoc = "<IMG id='navigationhome' alt='' src='HomeInactif.png' hspace='0' vspace='0' border='0'>"
  if htmlTxt.find(homeLoc) != -1:
    #trouver le filename correct (indpendamment du projet en cours): ouvrir la toc.hhc, trouver le 1er topic
    tocTxt = euresys.readFromFile("toc.hhc")
    #rechercher le premier topic
    reFilename = re.compile("<param name=\"Local\" value=\"(.*?\.htm)\">")
    filenames = reFilename.findall(tocTxt)
    if len(filenames) != 0:
      firstFileName = filenames[0]
      newHome = "<a href=\"" + firstFileName + "\" target=\"_self\"><IMG id='imgNavHome' alt='Home' src='HomeNEUTRE.png' hspace='0' vspace='0' border='0'></A>"
      #remplacer
      htmlTxt = htmlTxt.replace(homeLoc, newHome)
      flag = "True"

  #restera  supprimer les 3 liens autognrs avec <aitdata>, dsormais superflus (le tableau des related topics)
  related = reRelated.findall(htmlTxt)
  if len(related) != 0:
    #supprimer ce tableau de related topics
    htmlTxt = htmlTxt.replace(related[0], "")
    flag = "True"

  #remplacer <!-- Contact Us -->, <!-- Disclaimer -->, <!-- About Euresys Documentation --> par filenames corrects (indpendamment du projet en cours)      
  for title in ["Contact Us", "Disclaimer", "About Euresys Documentation"]:
    reTitle = re.compile("<!-- " + title + " -->")
    locations = reTitle.findall(htmlTxt)
    if len(locations) == 1:
      htmlTxt = htmlTxt.replace(locations[0], euresys.getFileName(title))
      flag = "True"

  #si le fichier a t modifi, le remplacer
  if flag == "True":
    euresys.writeToFile(f, htmlTxt)

#message de fin
print "----------</RewriteNavigation.py>----------"
