#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys


#message de dbut
print "----------<TuneScopeTables.py>----------"

#construction de l'expression rgulire qui trouvera les paires (board, (non-)relevant)
rePaires = re.compile("<td .*?><p class=\"cellcenter\"><span class=\"(.*?)\">(.*?)</span>", re.IGNORECASE)

#construction de l'expression rgulire qui trouvera toute la zone des anciens tableaux  remplacer
reActualScopeTables = re.compile("(<p class=\"tabletitle\">Scope</p>.*?)<p class=\"tabletitle\">Description</p>", re.IGNORECASE | re.DOTALL)

#excution sur tous les fichiers htm du dossier
for f in os.listdir('.'):
  if euresys.getFileExtension(f) != ".htm":
    continue

  #ouvrir le fichier
  htmlTxt = euresys.readFromFile(f)
  
  flag = "False"
  newScopeTables = ""

  #trouver les anciens tableaux
  actualScopeTables = reActualScopeTables.findall(htmlTxt)
  #si on en a trouv (il n'y en a que dans le MultiCam Reference)
  if len(actualScopeTables) == 1:
    #isoler les paires dans ce qu'on a trouv
    founds = rePaires.findall(actualScopeTables[0])
    #si on a trouv des paires
    if len(founds) != 0:
      try:
        #for eachFound in founds:
          #print eachFound[1] + ": " + eachFound[0]
        #construire les nouveaux beaux tableaux
        newScopeTables += "<TABLE id='PicoloTable'>\n"
        newScopeTables += "<TR>\n"
        if founds[6][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[0][0] + "'><a href='96434.htm' alt='Picolo Handbook'>Picolo</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[0][0] + "'>Picolo</TD>\n"
        if founds[6][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[1][0] + "'><a href='26652.htm' alt='Picolo Junior 4 Handbook'>Picolo Junior&nbsp;4</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[1][0] + "'>Picolo Junior&nbsp;4</TD>\n"
        if founds[6][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[2][0] + "'><a href='51526.htm' alt='Picolo Pro 2 Handbook'>Picolo Pro&nbsp;2</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[2][0] + "'>Picolo Pro&nbsp;2</TD>\n"
        if founds[6][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[3][0] + "'><a href='51528.htm' alt='Picolo Pro 3 Handbook'>Picolo Pro&nbsp;3</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[3][0] + "'>Picolo Pro&nbsp;3</TD>\n"
        if founds[6][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[4][0] + "'><a href='51530.htm' alt='Picolo Tetra Handbook'>Picolo Tetra</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[4][0] + "'>Picolo Tetra</TD>\n"
        if founds[6][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[5][0] + "'><a href='51534.htm' alt='Picolo Tymo Handbook'>Picolo Tymo</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[5][0] + "'>Picolo Tymo</TD>\n"
        if founds[6][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[6][0] + "'><a href='18356.htm' alt='Picolo Alert Handbook'>Picolo Alert</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[6][0] + "'>Picolo Alert</TD>\n"
        if founds[7][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[7][0] + "'><a href='26338.htm' alt='Picolo Diligent Handbook'>Picolo Diligent</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[7][0] + "'>Picolo Diligent</TD>\n"
        newScopeTables += "</TR>\n"
        newScopeTables += "</TABLE>\n"
        newScopeTables += "<TABLE id='DominoTable'>\n"
        newScopeTables += "<TR>\n"
        if founds[8][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[8][0] + "'><a href='47750.htm' alt='Domino Iota Handbook'>Domino Iota</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[8][0] + "'>Domino Iota</TD>\n"
        if founds[9][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[9][0] + "'><a href='51540.htm' alt='Domino Alpha 2 Handbook'>Domino Alpha&nbsp;2</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[9][0] + "'>Domino Alpha&nbsp;2</TD>\n"
        if founds[10][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[10][0] + "'><a href='51541.htm' alt='Domino Delta Handbook'>Domino Delta</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[10][0] + "'>Domino Delta</TD>\n"
        if founds[11][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[11][0] + "'><a href='51542.htm' alt='Domino Melody Handbook'>Domino Melody</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[11][0] + "'>Domino Melody</TD>\n"
        if founds[12][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[12][0] + "'><a href='51543.htm' alt='Domino Harmony Handbook'>Domino Harmony</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[12][0] + "'>Domino Harmony</TD>\n"
        if founds[13][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[13][0] + "'><a href='70645.htm' alt='Domino Symphony Handbook'>Domino Symphony</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[13][0] + "'>Domino Symphony</TD>\n"
        newScopeTables += "</TR>\n"
        newScopeTables += "</TABLE>\n"
        newScopeTables += "<TABLE id='GrablinkTable'>\n"
        newScopeTables += "<TR>\n"
        if founds[14][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[14][0] + "'><a href='26547.htm' alt='Grablink Value Handbook'>Grablink Value</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[14][0] + "'>Grablink Value</TD>\n"
        if founds[15][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[15][0] + "'><a href='26548.htm' alt='Grablink Expert 2 Handbook'>Grablink Expert&nbsp;2</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[15][0] + "'>Grablink Expert&nbsp;2</TD>\n"
        if founds[16][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[16][0] + "'><a href='26491.htm' alt='Grablink Avenue Handbook'>Grablink Avenue</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[16][0] + "'>Grablink Avenue</TD>\n"
        if founds[17][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[17][0] + "'><a href='51606.htm' alt='Grablink Express Handbook'>Grablink Express</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[17][0] + "'>Grablink Express</TD>\n"
        if founds[18][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[18][0] + "'><a href='27053.htm' alt='Grablink Quickpack ColorScan Handbook'>Grablink Quickpack ColorScan</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[18][0] + "'>Grablink Quickpack ColorScan</TD>\n"
        if founds[19][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[19][0] + "'><a href='26339.htm' alt='Grablink Quickpack CFA Handbook'>Grablink Quickpack CFA</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[19][0] + "'>Grablink Quickpack CFA</TD>\n"
        if founds[20][0] == "hyperlink":
          newScopeTables += "<TD class='td" + founds[20][0] + "'><a href='96400.htm' alt='Grablink Full Handbook'>Grablink Full</a></TD>\n"
        else:
          newScopeTables += "<TD class='td" + founds[20][0] + "'>Grablink Full</TD>\n"
        newScopeTables += "</TR>\n"
        newScopeTables += "</TABLE>\n"
      except IndexError:
        print "Error in " + f + " ."
        
      #remplacer les anciens tableaux trouvs par newScopeTables 
      if newScopeTables != "":
        htmlTxt = htmlTxt.replace(actualScopeTables[0], newScopeTables)
        flag = "True"


  #si le fichier a t modifi, le remplacer
  if flag == "True":
    euresys.writeToFile(f, htmlTxt)

#message de fin
print "----------</TuneScopeTables.py>----------"
