#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import shutil
import urllib
import euresys

#ce script gnre le fichier index.htm (le fichier d'entre)  la place d'Author-IT
#index.htm n'est gnr par AIT que quand on publie to HTML
#or je voudrais qu'il soit gnr aussi quand on publie to CHM
#(ainsi, on gnre les 2 versions en une seule fois)
#ce script ncessite d'avoir dans le mme dossier le fichier jobname.hhp

#message de dbut
print "----------<CreateDefaultHtmPageFromHhp.py>----------"

reTitle = re.compile("Title=(.*)", re.IGNORECASE)
reDefaultTopic = re.compile("Default topic=(.*?\.htm)", re.IGNORECASE)
reTitleLocation = re.compile("<TITLE></TITLE>", re.IGNORECASE)
reDefaultTopicLocation = re.compile("strReturn = \"Main.htm\"", re.IGNORECASE)

jobName = euresys.getJobName()

#rcuprer le contenu du fichier jobname.hhp
hhpTxt = euresys.readFromFile(jobName + ".hhp")

#rechercher le title
title = reTitle.findall(hhpTxt)
if len(title) != 0:
    title = title[0]
    print "title = " + title
#rechercher le default topic
defaultTopic = reDefaultTopic.findall(hhpTxt)
if len(defaultTopic) != 0:
    defaultTopic = defaultTopic[0]
    print "defaultTopic = " + defaultTopic
    
##################################################################
##s'il y a un frameset, c'est le frameset qui devient index.htm
try:
    #ouvrir et lire le fichier html_frameset.htm
    framesetFile = open("html_frameset.htm","r+")
    framesetTxt = framesetFile.read()
    framesetFile.close()
    #rechercher l'endroit pour le title et le remplacer
    titleLoc = reTitleLocation.findall(framesetTxt)
    if len(titleLoc) != 0:
        framesetTxt = framesetTxt.replace(titleLoc[0], "<TITLE>" + title + "</TITLE>")
    #rechercher l'endroit pour le default topic et le remplacer
    defaultTopicLoc = reDefaultTopicLocation.findall(framesetTxt)
    if len(defaultTopicLoc) != 0:
        framesetTxt = framesetTxt.replace(defaultTopicLoc[0], "strReturn = \"" + defaultTopic + "\"")

    #sauver le fichier sous index.htm
    euresys.writeToFile("index.htm", framesetTxt)

##################################################################
##s'il n'y a pas de frameset, c'est le default topic qui devient index.htm
except IOError:
    #copier le default topic sous index.htm
    defaultTxt = euresys.readFromFile(defaultTopic)
    euresys.writeToFile("index.htm", defaultTxt)


#message de fin
print "----------</CreateDefaultHtmPageFromHhp.py>----------"
