#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys

#message de dbut
print "----------<ImproveManualIndex.py>----------"

#dans le fichier index.hhk
#trouver la ligne au-dessus de about:blank et la ddoubler
#puis remplacer about:blank par javascript:void(0)

#<param name="Name" value="License">
#<param name="Local" value="about:blank">

reMissingLine = re.compile("(<param name=\"Name\" value=\".*?\">)(\s*?)<param name=\"Local\" value=\"about:blank\">")
reAboutBlank = re.compile("about:blank", re.DOTALL)
reDoubleLine = re.compile("<param name=\"Name\" value=\".*?\">(\s*?<param name=\"Name\" value=\".*?\">)")
   
#ouvrir le fichier index.hhk
indexTxt = euresys.readFromFile("index.hhk")

flag = "False"

#rechercher ligne prcdant about:blank    
founds = reMissingLine.findall(indexTxt)
if len(founds) != 0:
  flag = "True"
  for eachFound in founds:
    #print eachFound
    indexTxt = indexTxt.replace(eachFound[0], eachFound[0] + eachFound[1] + eachFound[0])
    
#rechercher/supprimer les doubles lignes (cafouillage entre nom du fichier target et nom de l'entre d'index)
#c'est la 1re ligne qu'on garde >> supprimer la 2e
##founds = reDoubleLine.findall(indexTxt)
##if len(founds) != 0:
##  flag = "True"
##  for eachFound in founds:
##    indexTxt = indexTxt.replace(eachFound, "")   

#rechercher/remplacer about:blank    
founds = reAboutBlank.findall(indexTxt)
if len(founds) != 0:
  flag = "True"
  for eachFound in founds:
    indexTxt = indexTxt.replace(eachFound, "javascript:void(0)")

if flag == "True":
  euresys.writeToFile("index.hhk", indexTxt)

#message de fin
print "----------</ImproveManualIndex.py>----------"

