#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys


#message de dbut
print "----------<InsertBuildNumber.py>----------"

#emplacement du fichier de suivi des builds
BuildsFile = "\\\\Yoko-tsuno\\Departments\\Communications\\Documentation\\Documents_AIT\\Templates\\HTML\\COMMON\\BuildsFile.txt"

#construction de l'expression rgulire qui trouvera le nom de la current doc (1er titre dans hierarchy)
reDoc = re.compile("<P id='hierarchy' class='Hierarchy'><a href=\".*?.htm\" target=\"_self\".*?>(.*?)</a>", re.IGNORECASE)

#valeur par dfaut pour doc inconnue si aucune doc trouve dans aucun fichier du dossier projet
DOC = "Unknown documentation"

#=======================================================
#lecture et incrment du BuildNumber

#recherche du nom du produit dans le 1er htm trouv
for f in os.listdir('.'):
  if euresys.getFileExtension(f) != ".htm":
    continue
  print "Looking for DOC in " + f + "..."

  #ouvrir le fichier
  htmlTxt = euresys.readFromFile(f)

  #recherche de DOC
  DOC = reDoc.findall(htmlTxt)
  #si trouv dans fichier, on sort de la boucle (break)
  if len(DOC) == 1:
    DOC = DOC[0]
    DOC = DOC.replace(" ", "")
    DOC = DOC.replace(".", "")
    DOC = DOC.replace("-", "")
    DOC = DOC.replace("/", "")
    print "DOC = " + DOC
    break
  #si pas trouv, on cherche dans le fichier suivant
  else:
    continue

#ouvrir le fichier des builds
BTxt = euresys.readFromFile(BuildsFile)

#recherche du numro de build dans BuildsFile.txt
reBuildNumber = re.compile(DOC.replace("+", "\+") + "\s(\d+)")
BuildNumbers = reBuildNumber.findall(BTxt)
if len(BuildNumbers) == 1:
  BuildNumber = BuildNumbers[0]
else:
  BuildNumber = "new"
print "BuildNumber = " + BuildNumber

#incrmenter le build number
if BuildNumber != "new":
  NewBuildNumber = str(int(BuildNumber) + 1)
  print "NewBuildNumber = " + NewBuildNumber
  NewBuildString = " (doc build " + NewBuildNumber + ")"
  BTxt = BTxt.replace(DOC + ' ' + BuildNumber, DOC + ' ' + NewBuildNumber)
else:
  NewBuildString = " (doc build 1)"
  BTxt = BTxt + DOC + " 0\n"
  
#crire dans BuildsFile
euresys.writeToFile(BuildsFile, BTxt)
    
#=======================================================

#excution sur tous les fichiers htm du dossier
for f in os.listdir('.'):
  if euresys.getFileExtension(f) != ".htm":
    continue

  #ouvrir le fichier
  htmlTxt = euresys.readFromFile(f)
  
  flag = "False"

  #reBuildNumber
  if htmlTxt.find("<!-- BUILDNUMBER -->") != -1:
    htmlTxt = htmlTxt.replace("<!-- BUILDNUMBER -->", NewBuildString)
    flag = "True"

  #si le fichier a t modifi, le remplacer
  if flag == "True":
    euresys.writeToFile(f, htmlTxt)

#message de fin
print "----------</InsertBuildNumber.py>----------"
