#!/usr/bin/python
# -*- coding: latin-1 -*-

import os
import shutil
import tarfile
import euresys

#message de dbut
print "----------<PackOfflineLinuxVersion.py>----------"

#Maintenant que la version Linux est passe par la case Zoom Search Engine,
#archiver en tar gz le dossier "html"

#nom du projet en cours (dossier parent)
project = euresys.getJobName()
if project == "MultiCam_Boards_Documentation":
    docName = "multiCam"
elif project == "PICOLO_V16H264_VFS_Documentation":
    docName = "picolo-v16-h264"
elif project == "PICOLO_U4H264PCI104_VFS_Documentation":
    docName = "picolo-u4-h264-pci104"
elif project == "PICOLO_U4U8U16H264_VFS_Documentation":
    docName = "picolo-u4-u8-u16-h264"
else:
    raise Exception, "*** ERROR *** Unknown project name: " + project
            
htmlFilesPath = "html"

version = euresys.getDocumentationVersion()
version += '-vfs'
archivePath = "%s-linux-%s-documentation.tar.gz" % (docName.lower(), version)
print archivePath

#archiver en .tar.gz
tf = tarfile.open(archivePath, "w:gz")
try:
    tf.add(htmlFilesPath, os.path.basename(htmlFilesPath))
finally:
    tf.close()

#creation du chemin de destination sur Release_Documentation
targetPath = "\\\\Yoko-tsuno\\Euresys\\Release_Documentation\\Documentation\\%s\\%s\\" % (docName, version)
if not os.path.exists(targetPath):
    os.mkdir(targetPath)

#x86TargetPath = os.path.join(targetPath, archivePath)
#x64TargetPath = x86TargetPath.replace('x86', 'x86-64')

#copie de la doc 32bit et 64bit sur Release_Documentation
shutil.copy(archivePath, targetPath)
#shutil.copy(x86TargetPath, x64TargetPath)

#cleanup
shutil.rmtree(htmlFilesPath, ignore_errors=True)
os.remove(archivePath)

print "----------</PackOfflineLinuxVersion.py>----------"
