#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys

#message de dbut
print "----------<RemoveUnneededText.py>----------"

#chaque string de la liste searched sera cherche dans chaque fichier et supprime
searched = euresys.getPrivateStringsList()


reHStart = re.compile("<h[789]", re.DOTALL | re.IGNORECASE)
reHEnd = re.compile("</h[789]>", re.DOTALL | re.IGNORECASE)
reOL = re.compile("<OL class=\"listnumber?\">", re.IGNORECASE)
   
#excution sur tous les fichiers htm du dossier, et sur la toc.hhc, et sur l'index.hhk
for f in os.listdir('.'):
  if euresys.getFileExtension(f) != ".htm" and euresys.getFileExtension(f) != ".hhc" and euresys.getFileExtension(f) != ".hhk":
    continue

  #ouvrir le fichier
  htmlTxt = euresys.readFromFile(f)

  #suppression des expressions listes dans searched    
  for string in searched:
    #supprimer le \n de fin de ligne
    string = string.rstrip()
    #ajouter le caractre d'chappement \ aux caractres non alphanumriques
    string = re.escape(string)
    founds = re.compile(string).findall(htmlTxt)
    if len(founds) != 0:
      for eachFound in founds:
        print eachFound
        htmlTxt = htmlTxt.replace(eachFound, "")

  #reHStart >> correction FB case 4278 <h7> is not a valid html tag
  founds = reHStart.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, "<P")

  #reHEnd >> correction FB case 4278 <h7> is not a valid html tag
  founds = reHEnd.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, "</P>")

  #reOL >> correction OL, pas d'attribut class, problme de numrotation auto en IE
  founds = reOL.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, "<OL>")

  #PicoloClassic
  htmlTxt = htmlTxt.replace("Picolo Classic", "Picolo")

  #Ampersand
  htmlTxt = htmlTxt.replace("@amp@", "&amp;")
  
  #corriger certains doublons de tags autour des fichiers externes embedds (code snippets)
  htmlTxt = htmlTxt.replace("<p class=\"example\"><p class='example'>", "<p class='example'>")
  htmlTxt = htmlTxt.replace("<p class=\"example\"><p class='comment'>", "<p class='comment'>")
  htmlTxt = htmlTxt.replace("</p></p>", "</p>")
  htmlTxt = htmlTxt.replace("<p class=\"example\"><PRE class='Snippet'>", "<div class='Snippet'><pre>")
  htmlTxt = htmlTxt.replace("</PRE></p>", "</pre></div>")
  
  euresys.writeToFile(f, htmlTxt)

#message de fin
print "----------</RemoveUnneededText.py>----------"

