#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys


#message de dbut
print "----------<ReplaceCodeDivs.py>----------"

#construction des expressions rgulires
reEndDiv = re.compile("<p class=\"div\">&lt;/DIV&gt;</p>", re.DOTALL | re.IGNORECASE)
reDivPICOLO = re.compile("<p class=\"div\">&lt;DIV id=&quot;PICOLO&quot;&gt;</p>", re.DOTALL | re.IGNORECASE)
reDivDOMINO = re.compile("<p class=\"div\">&lt;DIV id=&quot;DOMINO&quot;&gt;</p>", re.DOTALL | re.IGNORECASE)
reDivGRABLINK = re.compile("<p class=\"div\">&lt;DIV id=&quot;GRABLINK&quot;&gt;</p>", re.DOTALL | re.IGNORECASE)
reDivCPP = re.compile("<p class=\"div\">&lt;DIV id=&quot;CPP&quot;&gt;</p>", re.DOTALL | re.IGNORECASE)
reDivNET = re.compile("<p class=\"div\">&lt;DIV id=&quot;NET&quot;&gt;</p>", re.DOTALL | re.IGNORECASE)
reDivAX = re.compile("<p class=\"div\">&lt;DIV id=&quot;AX&quot;&gt;</p>", re.DOTALL | re.IGNORECASE)

   
#excution sur tous les fichiers htm du dossier
for f in os.listdir('.'):
  if euresys.getFileExtension(f) != ".htm":
    continue

  #ouvrir le fichier
  htmlTxt = euresys.readFromFile(f)
  
  flag = "False"

  #reEndDiv
  founds = reEndDiv.findall(htmlTxt)
  if len(founds) != 0:
      for eachFound in founds:
          htmlTxt = htmlTxt.replace(eachFound, "</DIV>")
      flag = "True"
      
  #reDivPICOLO
  founds = reDivPICOLO.findall(htmlTxt)
  if len(founds) != 0:
      for eachFound in founds:
          htmlTxt = htmlTxt.replace(eachFound, "<DIV id='PICOLO'>")
      flag = "True"
      
  #reDivDOMINO
  founds = reDivDOMINO.findall(htmlTxt)
  if len(founds) != 0:
      for eachFound in founds:
          htmlTxt = htmlTxt.replace(eachFound, "<DIV id='DOMINO'>")
      flag = "True"
      
  #reDivGRABLINK
  founds = reDivGRABLINK.findall(htmlTxt)
  if len(founds) != 0:
      for eachFound in founds:
          htmlTxt = htmlTxt.replace(eachFound, "<DIV id='GRABLINK'>")
      flag = "True"
      
  #reDivCPP
  founds = reDivCPP.findall(htmlTxt)
  if len(founds) != 0:
      for eachFound in founds:
          htmlTxt = htmlTxt.replace(eachFound, "<DIV id='CPP'>")
      flag = "True"
      
  #reDivNET
  founds = reDivNET.findall(htmlTxt)
  if len(founds) != 0:
      for eachFound in founds:
          htmlTxt = htmlTxt.replace(eachFound, "<DIV id='NET'>")
      flag = "True"
      
  #reDivAX
  founds = reDivAX.findall(htmlTxt)
  if len(founds) != 0:
      for eachFound in founds:
          htmlTxt = htmlTxt.replace(eachFound, "<DIV id='AX'>")
      flag = "True"


  #si le fichier a t modifi, le remplacer
  if flag == "True":
    euresys.writeToFile(f, htmlTxt)

#message de fin
print "----------</ReplaceCodeDivs.py>----------"
