#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys

#message de dbut
print "----------<RewriteSpecialChars.py>----------"

reMu1 = re.compile("<span class=\"symb\">m</span>")
reMu2 = re.compile("<span class=\"symbols\">m</span>")
reOmega1 = re.compile("<span class=\"symb\">W</span>")
reOmega2 = re.compile("<span class=\"symbols\">W</span>")
reSigma1 = re.compile("<span class=\"symb\">s</span>")
reSigma2 = re.compile("<span class=\"symbols\">s</span>")
reCheck = re.compile("<span class=\"wing\"></span>")
reLessOrEqual = re.compile("<span class=\"symbols\"></span>")
reNonBreakingHyphen = re.compile("")
   
#excution sur tous les fichiers htm du dossier
for f in os.listdir('.'):
  if euresys.getFileExtension(f) != ".htm":
    continue

  #ouvrir le fichier
  htmlTxt = euresys.readFromFile(f)
  
  flag = "False"

  #mu
  founds = reMu1.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, "&mu;")
    flag = "True"
  founds = reMu2.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, "&mu;")
    flag = "True"

  #Omega
  founds = reOmega1.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, "&Omega;")
    flag = "True"
  founds = reOmega2.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, "&Omega;")
    flag = "True"

  #sigma
  founds = reSigma1.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, "&sigma;")
    flag = "True"
  founds = reSigma2.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, "&sigma;")
    flag = "True"

  #check mark
  founds = reCheck.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, "&#10003;")
    flag = "True"

  #less or equal
  founds = reLessOrEqual.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, "&le;")
    flag = "True"
      
  #reNonBreakingHyphen
  founds = reNonBreakingHyphen.findall(htmlTxt)
  if len(founds) != 0:
    for eachFound in founds:
      htmlTxt = htmlTxt.replace(eachFound, "&minus;")
    flag = "True"
  
  if flag == "True":
    #crire dans le fichier
    euresys.writeToFile(f, htmlTxt)


#message de fin
print "----------</RewriteSpecialChars.py>----------"

